import { Subject } from 'rxjs';
import { filter, take } from 'rxjs/operators';
import { Injectable, ApplicationRef, NgZone, NgModule, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapModalService {
    /**
     * @param {?} _appRef
     * @param {?} _zone
     */
    constructor(_appRef, _zone) {
        this._appRef = _appRef;
        this._zone = _zone;
    }
    /**
     * @return {?}
     */
    get appRef() {
        return this._appRef;
    }
    /**
     * @return {?}
     */
    get zone() {
        return this._zone;
    }
    /**
     * @param {?} templateRef
     * @return {?}
     */
    show(templateRef) {
        /** @type {?} */
        const events$ = new Subject();
        /** @type {?} */
        const instance = {
            shown: new Promise(resolve => {
                events$
                    .pipe(filter(e => 'shown' === e.type))
                    .pipe(take(1))
                    .subscribe(() => {
                    this.zone.run(resolve);
                });
            }),
            hidden: new Promise(resolve => {
                events$
                    .pipe(filter(e => 'hidden' === e.type))
                    .pipe(take(1))
                    .subscribe(() => resolve());
            }),
            events: events$.asObservable(),
            hide: null,
            handleUpdate: null
        };
        /** @type {?} */
        const viewRef = templateRef.createEmbeddedView({ instance: instance });
        this.appRef.attachView(viewRef);
        /** @type {?} */
        const el = viewRef.rootNodes[0];
        document.body.appendChild(el);
        /** @type {?} */
        const $el = jQuery(el);
        $el.modal({ show: false });
        $el.on('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal', (event) => {
            this.zone.run(() => {
                events$.next(event);
            });
        });
        instance.hide = () => {
            $el.modal('hide');
            return instance.hidden;
        };
        instance.handleUpdate = () => {
            $el.modal('handleUpdate');
        };
        instance.hidden.then(() => {
            $el.off('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal');
            $el.modal('dispose');
            document.body.removeChild(el);
            this.appRef.detachView(viewRef);
            viewRef.destroy();
        });
        $el.modal('show');
        return instance;
    }
}
NgxBootstrapModalService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxBootstrapModalService.ctorParameters = () => [
    { type: ApplicationRef },
    { type: NgZone }
];
/** @nocollapse */ NgxBootstrapModalService.ngInjectableDef = defineInjectable({ factory: function NgxBootstrapModalService_Factory() { return new NgxBootstrapModalService(inject(ApplicationRef), inject(NgZone)); }, token: NgxBootstrapModalService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapModalModule {
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: NgxBootstrapModalModule,
            providers: [NgxBootstrapModalService]
        };
    }
}
NgxBootstrapModalModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                imports: [],
                exports: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapModalService, NgxBootstrapModalModule };

//# sourceMappingURL=nowzoo-ngx-bootstrap-modal.js.map