import { Subject } from 'rxjs';
import { filter, take } from 'rxjs/operators';
import { Injectable, ApplicationRef, NgZone, NgModule, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapModalService = /** @class */ (function () {
    function NgxBootstrapModalService(_appRef, _zone) {
        this._appRef = _appRef;
        this._zone = _zone;
    }
    Object.defineProperty(NgxBootstrapModalService.prototype, "appRef", {
        get: /**
         * @return {?}
         */
        function () {
            return this._appRef;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapModalService.prototype, "zone", {
        get: /**
         * @return {?}
         */
        function () {
            return this._zone;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} templateRef
     * @return {?}
     */
    NgxBootstrapModalService.prototype.show = /**
     * @param {?} templateRef
     * @return {?}
     */
    function (templateRef) {
        var _this = this;
        /** @type {?} */
        var events$ = new Subject();
        /** @type {?} */
        var instance = {
            shown: new Promise(function (resolve) {
                events$
                    .pipe(filter(function (e) { return 'shown' === e.type; }))
                    .pipe(take(1))
                    .subscribe(function () {
                    _this.zone.run(resolve);
                });
            }),
            hidden: new Promise(function (resolve) {
                events$
                    .pipe(filter(function (e) { return 'hidden' === e.type; }))
                    .pipe(take(1))
                    .subscribe(function () { return resolve(); });
            }),
            events: events$.asObservable(),
            hide: null,
            handleUpdate: null
        };
        /** @type {?} */
        var viewRef = templateRef.createEmbeddedView({ instance: instance });
        this.appRef.attachView(viewRef);
        /** @type {?} */
        var el = viewRef.rootNodes[0];
        document.body.appendChild(el);
        /** @type {?} */
        var $el = jQuery(el);
        $el.modal({ show: false });
        $el.on('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal', function (event) {
            _this.zone.run(function () {
                events$.next(event);
            });
        });
        instance.hide = function () {
            $el.modal('hide');
            return instance.hidden;
        };
        instance.handleUpdate = function () {
            $el.modal('handleUpdate');
        };
        instance.hidden.then(function () {
            $el.off('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal');
            $el.modal('dispose');
            document.body.removeChild(el);
            _this.appRef.detachView(viewRef);
            viewRef.destroy();
        });
        $el.modal('show');
        return instance;
    };
    NgxBootstrapModalService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapModalService.ctorParameters = function () { return [
        { type: ApplicationRef },
        { type: NgZone }
    ]; };
    /** @nocollapse */ NgxBootstrapModalService.ngInjectableDef = defineInjectable({ factory: function NgxBootstrapModalService_Factory() { return new NgxBootstrapModalService(inject(ApplicationRef), inject(NgZone)); }, token: NgxBootstrapModalService, providedIn: "root" });
    return NgxBootstrapModalService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapModalModule = /** @class */ (function () {
    function NgxBootstrapModalModule() {
    }
    /**
     * @return {?}
     */
    NgxBootstrapModalModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NgxBootstrapModalModule,
            providers: [NgxBootstrapModalService]
        };
    };
    NgxBootstrapModalModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [],
                    imports: [],
                    exports: []
                },] }
    ];
    return NgxBootstrapModalModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapModalService, NgxBootstrapModalModule };

//# sourceMappingURL=nowzoo-ngx-bootstrap-modal.js.map